Bug 43011 - Simplify SDK vs min target OS settings
Summary: Simplify SDK vs min target OS settings
Status: VERIFIED FIXED
Alias: None
Product: Xamarin Studio
Classification: Desktop
Component: Mac Add-in (show other bugs)
Version: 6.1.0 (C8)
Hardware: PC Mac OS
: --- normal
Target Milestone: master
Assignee: Jeffrey Stedfast
URL:
Depends on:
Blocks:
 
Reported: 2016-08-02 19:14 UTC by Aaron Bockover [MSFT]
Modified: 2016-09-20 18:38 UTC (History)
2 users (show)

See Also:
Tags:
Is this bug a regression?: ---
Last known good build:


Attachments
MacOSXSdkVersion UI (39.48 KB, image/png)
2016-08-02 19:14 UTC, Aaron Bockover [MSFT]
Details

Description Aaron Bockover [MSFT] 2016-08-02 19:14:38 UTC
Created attachment 16869 [details]
MacOSXSdkVersion UI

The SDK target settings in the Mac addin/MSBuild target is confusing and a little out of date. Given that for a while now Xcode releases only ship with the latest SDK release, there is no reason to offer SDK choice in the Mac build settings.

For example, we target 10.10, but Xcode 8 only provides 10.12 SDK. This is okay! However, the target cannot find the 10.10 SDK, and claims it will use the latest (10.12) instead. This is alarming. It implies that the app binary will be built for 10.12, and not 10.10.

> /Library/Frameworks/Mono.framework/External/xbuild/Xamarin/Mac/Xamarin.Mac.Common.targets:  warning : The MacOSX SDK version '10.10' is not installed. Using newer version '10.12' instead'.

However, the only value that effectively matters is the SDK version in the Info.plist. This value is correctly passed to mmp, and then on to clang to become -mmacosx-version-min=10.10.

The reality is that nothing is wrong, but there's a UI that controls a useless setting, and produces a scary warning.

So... my proposal is the following:

  1. ensure that XS, the XM build targets/tasks, and mmp use the Xcode located at `xcode-select -p` - I think this is already the case, but it would probably be a good idea to confirm that. It's a good/standard policy.

  2. Remove the MacOSXSdkVersion project option altogether. This was used only to try to locate the SDK directory inside an Xcode installation. Given that (a) we should only use the Xcode resolved by (1) and (b) that Xcode ships with exactly one SDK, this option is pointless.

  3. Remove the associated UI for manipulating MacOSXSdkVersion inside the XS build pane.

The Info.plist UI is already correct in that it offers 10.7 through the latest version provided by the SDK found in the Xcode resoled by (1).
Comment 1 Jeffrey Stedfast 2016-08-02 19:23:31 UTC
MSBuild changes required for this fix: https://github.com/xamarin/xamarin-macios/pull/528
XS change: md-addins commit 19d124b6f4568a7ce8f261bae4a6e6aa7f9a5cab
Comment 2 xamarin-release-manager 2016-08-03 06:52:25 UTC
Fixed in version 6.1.0.5301 (cycle8)

Author: Jeffrey Stedfast
Commit: ebe65cf5c35eeb29044578940e4568d7f3b470e0 (xamarin/md-addins)
Included in Commit: d728db2d8c210fe772cf1ebf4ac7f518165ac960 (mono/monodevelop)

Notice (2018-05-21): bugzilla.xamarin.com will be switching to read-only mode on Thursday, 2018-05-25 22:00 UTC.

Please join us on Visual Studio Developer Community and GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs and copy them to the new locations as needed for follow-up. The See Also field on each Bugzilla bug will be updated with a link to its new location when applicable.

After Bugzilla is read-only, if you have new information to add for a bug that does not yet have a matching issue on Developer Community or GitHub, you can create a follow-up issue in the new location. Copy and paste the title and description from this bug, and then add your new details. You can get a pre-formatted version of the title and description here:

In special cases you might also want the comments:

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.

Note You need to log in before you can comment on or make changes to this bug.